#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int myargc = 0;
char ** myargv = 0;
char * srcfile = 0;
char * objfile = 0;
char * parsefile = 0;
void a68cio_publish_parameters(int argc, char **argv)
{ 
  parsefile = "PARSE";
  myargc = argc;
  myargv = argv;
  int i;
  i = 0;
  while((++i) < argc)
    {
      char * arg = argv[i];
      if(! arg)
        continue;
      if(arg[0] == '-')
        {
          if(arg[1] == 'o')
	    {
	      ++i;
	      objfile = argv[i];
	      if( ! objfile)
		{
		  printf("no object file name after \"-o\".\n");
		  exit(4);
		}
	      continue;
	    }
          if(arg[1] == 'p')
	    {
	      ++i;
	      parsefile = argv[i];
	      if( ! parsefile)
		{
		  printf("no parse file name after \"-o\".\n");
		  exit(4);
		}
	      continue;
	    }
	  
	}
      if((strlen(arg) > 4) && (strcmp(arg + strlen(arg) - 4, ".a68") == 0))
        {
          if(srcfile)
	    { fprintf(stderr, "too many source files.\n");
              exit(4);
	    }
	  srcfile = strdup(arg);
          if(! objfile)
	    {
	      objfile = strdup(arg);
	      objfile[strlen(arg) - 3] = 'c';
	      objfile[strlen(arg) - 2] = '-';
	      objfile[strlen(arg) - 1] = '-';
	    }
          continue;
	}
    }
  if(! srcfile)
    {
      printf("nothing to do.\n");
      exit(4);
    }
  printf("source file %s\n", srcfile);
  printf("object file %s\n", objfile);
  printf("parse file from %s\n", parsefile);
}

char mycode(int i)
{
  return (char) i;
}

int mydecode(unsigned char c)
{
  return c;
}

static void cleanddname(char dd[8], char ch[9])
{
  int i;
  int foundstuff;

  foundstuff = 0;
  ch[8] = 0;
  for(i = 7; i >= 0; --i)
    {
      foundstuff |= (dd[i] != ' ');
      if(foundstuff)
	  ch[i] = dd[i];
      else ch[i] = 0;
    }
}

FILE * inopenbin(char dd[8])
{
  char * filename;
  FILE *f;
  char c[9];
  //  printf("still opening %.8s..\n", dd);
  cleanddname(dd, c);
  // printf("still opening %s..\n", c);
  if(strcmp(c, "A68HIN") == 0)
    {
      filename = srcfile;
    }
  else if(strcmp(c, "PARSE") == 0)
    {
      filename = parsefile;
    }
  else
    {
      filename = c;
    }
  // printf("will fopen %8s.\n", filename);
  f = fopen(filename, "rb");
  if( f ) printf("Opened %s.\n", filename);
    else printf("Cannot open %s.\n", filename);
  return f;
}

FILE * inopentxt(char dd[8])
{
  fprintf(stderr, "opening %.8s\n", dd);
  return inopenbin(dd);
}

int inopenp2(char dd[8])
{
  inopentxt(dd);
}

int readchar(FILE * file, char *c) // return success
{
  int ch = fgetc(file);
  if(ch < 0)
    {
      *c = ' ';;
      return 0;
    }      
  else
    {
      *c = ch;
      return 1;
    }
}

void closeout(FILE * file)
{
  fflush(file);
  fclose(file);
}

FILE * outopenbin(char dd[8])
{
  char * filename;
  FILE *f;
  char c[9];
  cleanddname(dd, c);
  if(strcmp(c, "A68JANUS") == 0)
    {
      filename = objfile;
    }
  else
    {
      filename = c;
    }
  f = fopen(filename, "wb");
  return f;
}

int f_emit(FILE * file, char s[40])
{
  fwrite(s, 1, 40, file);
}

FILE * outopentxt(char dd[8])
{
  return outopenbin(dd);  
}

void f_ei(FILE * f, int i)
{
  fwrite(&i, 1, sizeof(i), f);
}

void f_el(FILE * f, int l, char *c)
{
  fwrite(c, l, 1, f);
}

void f_ec(FILE * f, char c)
{
  fputc(c, f);
}

void f_eel(FILE * f)
{
  fputc('\n', f);
}

int f_readi(FILE * file, int *val) // return success
{
  int rc = fread(val, 1, sizeof(int), file);
  return rc == sizeof(int);
}

int f_readbits(FILE * file, int *val) // return success
{
  return f_readi(file, val);
}

int F_read8(FILE * file, char val[8], int maxlen)
  // return number of bytes read
{
  int rc = fread(val, 1, maxlen, file);
  return rc;
}

int f_readbitsblock(FILE * file, void * block, int maxlen)
  // return number of bytes read
{
  int rc = fread(block, 1, maxlen, file);
  return rc;
}

void inclose(FILE * file)
{
  fclose(file);
}

void puti(FILE * file, int value)
{
  fwrite(&value, 1, sizeof(value), file);
}

void put(FILE * file, int len, char * ch)
{
  fwrite(ch, 1, len, file);
}

void putb(FILE * file, int value)
{
  fwrite(&value, 1, sizeof(int), file);
}
