#include <stdio.h>
#include "instring.hh"


// Character output files; i.e., strings; i.e. sinks.

void inserter::flush(FILE * f)
{
  instring * p = this;
  for( p = this; p->prev != NULL; p = p->prev);
  while(p != NULL)
  {
    p->writemeonly(f);
    p = p->next;
  }
}



inserter * inserter::newinsertpoint()
// create and return a new insertion point before the existing one.
{
  inserter *erter;
  erter = new inserter;
  erter->prev = prev;
  erter->next = this;
  if(prev)prev->next = erter;
  prev = erter;
  return erter;
}

#define maxpiece 2

class inspiece : public instring
{
public:
  inspiece();
  int count;
  char chars[maxpiece];
  void writemeonly(FILE * f);
};

class subinserter : public instring
{
  inserter * sub;
public:
  subinserter(inserter *other) { sub = other; }
  void writemeonly(FILE *f){ sub->flush(f) ;}
  
};

void inserter::insert_inserter(inserter * other)
  {
    subinserter *sub = new subinserter(other);
    sub->prev = prev;
    sub->next = this;
    if(prev) prev->next = sub;
    prev = sub;
  }

inserter::inserter()
{
  prev = NULL;
  next = NULL;
}

inspiece::inspiece()
{
  prev = NULL;
  next = NULL;
  count = 0;
}
void inserter::writemeonly(FILE *file)
{
}


void inspiece::writemeonly(FILE *file)
{
  fwrite(chars, 1, count, file);
}

void inserter::insert(char c)
{
  inserter * ins;
  inspiece * piece;
  if((piece = dynamic_cast<inspiece *>(prev)) == NULL
     || (piece = dynamic_cast<inspiece *>(prev)) != NULL
        && piece->count >= maxpiece
     )
    {
      piece = new inspiece;
      piece->prev = prev;
      piece->next = this;
      if(prev)prev->next = piece;
      prev = piece;
    }
  piece->chars[piece->count++] = c;
}

/* this one is used as character in pass 5. */
void inserter::insert(int len, char *c)
{
  int i;
  for(i = 0; i < len; i++)
    {
      insert( c[i]);
    }
}

/* this one is used as character in pass 5. */
void inserter::insert(const char *c)
{
  const char *i;
  for(i = c; *i; i++)
    {
      insert( *i);
    }
}

void inserter::insert_eol()
{
  insert('\n');
}


// END Character output files; i.e., strings; i.e. sinks
  



/* The following stuff is the C interface to the oabove code.
   If it turns out that C can't bridge the gap between C++
   and Algol W, I'll have to devise something else, perhaps
   rewrite the C++ code in C.
*/

extern "C"
{

#include "inserter.h"

  struct inserter* make_inserter()
  {
    return new inserter();
  }

  struct inserter * newinsertpoint(struct inserter *i)
  {
    return i->newinsertpoint();
  }

  void insertchar(struct inserter *i, char c)
  {
    i->insert(c);
  }

  void insertlen(struct inserter *i, int len, char* s)
  {
    i->insert(len, s);
  }
  void inserteol(struct inserter *i)
  {
    i->insert_eol();
  }
  void flushinserter(struct inserter *s, FILE *f)
  {
    s->flush(f);
  }
  void writemeonly(struct inserter *s, FILE *f)
  {
    s->writemeonly(f);
  }
  void insert_inserter(struct inserter *s, struct inserter *sub)
  {
    s->insert_inserter(sub);
  }
}
